#|theme.jl

I want to make a theme that can read blackbox themes and display them as 
blackbox themes!!!

then I can rule the world! mua-ha-ha-ha!

first I'll clone the chaos blackbox theme, 
using pixmaps only for the buttons; then
I'll work on getting the sawfish theme to read in the blackbox theme and 
do the cloning itself.
|#
;;gotta have the gradients.
(require 'gradient)
;;not standard to be able to use rep.regexp
;;(require 'rep.regexp)

;;colors and styles -- copy more or less from the blackbox style.
;;skip all the toolbar/menu stuff- we only deal with window stuff.

;;gradient/texture info
;;this will have to be printed in by a script. as will most other stuff,
;;of course.
(define window.title.focus-props '((solid-gradient . gradient)
				   (grad-type . vertical)
				   (interlaced)
				   (depth . raised)
				   (bevel . bevel1)
				   (parent)))
(define window.title.unfocus-props '((solid-gradient . gradient)
				     (grad-type . vertical)
				     (interlaced)
				     (depth . raised)
				     (bevel . bevel1)
				     (parent)))
(define window.label.focus-props '((solid-gradient . gradient)
				   (grad-type . diagonal)
				   (interlaced . t)
				   (depth . sunken)
				   (bevel . bevel1)
				   (parent)))
(define window.label.unfocus-props '((solid-gradient . gradient)
				     (grad-type . diagonal)
				     (interlaced . t)
				     (depth . sunken)
				     (bevel . bevel1)
				     (parent)))
(define window.button.focus-props '((solid-gradient . gradient)
				    (grad-type . diagonal)
				    (interlaced . t)
				    (depth . raised)
				    (bevel . bevel1)
				    (parent)))
(define window.button.unfocus-props '((solid-gradient . gradient)
				      (grad-type . diagonal)
				      (interlaced . t)
				      (depth . raised)
				      (bevel . bevel1)
				      (parent)))
(define window.button.pressed-props '((solid-gradient . gradient)
				      (grad-type . diagonal)
				      (interlaced)
				      (depth . sunken)
				      (bevel . bevel1)
				      (parent)))
(define window.frame.focus-props '((solid-gradient . solid)
				   (grad-type . diagonal)
				   (interlaced . t)
				   (depth . sunken)
				   (bevel . bevel1)
				   (parent)))
(define window.frame.unfocus-props '((solid-gradient . solid)
				     (grad-type . diagonal)
				     (interlaced . t)
				     (depth . sunken)
				     (bevel . bevel1)
				     (parent)))
(define window.handle.focus-props '((solid-gradient . gradient)
				    (grad-type . vertical)
				    (interlaced)
				    (depth . raised)
				    (bevel . bevel1)
				    (parent)))
(define window.handle.unfocus-props '((solid-gradient . gradient)
				      (grad-type . diagonal)
				      (interlaced . t)
				      (depth . raised)
				      (bevel . bevel1)
				      (parent)))
(define window.grip.focus-props '((solid-gradient . gradient)
				  (grad-type . diagonal)
				  (interlaced . t)
				  (depth . raised)
				  (bevel . bevel1)
				  (parent)))
(define window.grip.unfocus-props '((solid-gradient . gradient)
				    (grad-type . diagonal)
				    (interlaced . t)
				    (depth . raised)
				    (bevel . bevel1)
				    (parent)))

;;color info
;;colors can come straight from the file!!!
;;titles
(define window.title.focus.color (get-color "rgb:60/78/90"))
(define window.title.focus.colorto (get-color "rgb:10/28/40"))
(define window.title.unfocus.color (get-color "rgb:30/40/50"))
(define window.title.unfocus.colorto (get-color "black"))
;;labels?
(define window.label.focus.color	(get-color "black"))
(define window.label.focus.colorto	(get-color "rgb:a0/a8/b0"))
(define window.label.focus.textcolor	(get-color "white"))
(define window.label.unfocus.color	(get-color "black"))
(define window.label.unfocus.colorto	(get-color "rgb:60/68/70"))
(define window.label.unfocus.textcolor	(get-color "rgb:70/78/80"))
;;buttons
(define window.button.focus.color	(get-color "rgb:a0/a8/b0"))
(define window.button.focus.colorto	(get-color "black"))
(define window.button.focus.piccolor	(get-color "white"))
(define window.button.unfocus.color	(get-color "rgb:60/68/70"))
(define window.button.unfocus.colorto	(get-color "black"))
(define window.button.unfocus.piccolor	(get-color "rgb:70/78/80"))
(define window.button.pressed.color	(get-color "rgb:10/28/40"))
(define window.button.pressed.colorto	(get-color "rgb:60/78/90"))
;;frames
(define window.frame.focuscolor	(get-color "rgb:70/78/80"))
(define window.frame.unfocuscolor	(get-color "rgb:40/48/50"))
;;handles
(define window.handle.focus.color	(get-color "rgb:50/68/80"))
(define window.handle.focus.colorto	(get-color "rgb:20/38/50"))
(define window.handle.unfocus.color	(get-color "rgb:30/48/60"))
(define window.handle.unfocus.colorto	(get-color "black"))
;;grips
(define window.grip.focus.color	(get-color "rgb:a0/a8/b0"))
(define window.grip.focus.colorto (get-color "black"))
(define window.grip.unfocus.color (get-color "rgb:60/68/70"))
(define window.grip.unfocus.colorto (get-color "black"))
;;border color
(define bordercolor (get-color "black"))
;;*phew* that's a lot of colors!!!

;;now the last few things:
(define window.justify 'center)
(define bevelwidth 2)
(define borderwidth 1)
(define handlewidth 5)
(define title-font (get-font "lucidasans-10"))

(define (interlace image)
  (image-fill
       ;;this is the generator, which will have to cheat a little.
       ;;the cheating is to refer to the image, even though the image
       ;;isn't an argument to the generator.
       (lambda (x y)
	 (if (evenp y)
	     ;;if we're on the right line, we subtract
	     ;;some number from each value of each pixel 
	     ;;to make a darkened line.
	     (mapcar (lambda (foo) 
		       (max (- foo 32) 0))
		     (image-ref image x y))
	 ;;if we're not on the right line, we just find the old pixel 
	 ;;and give it back!
	 (image-ref image x y)))
       image))


(define (build-blackbox-texture image props-alist color #!optional colorto)
  ;;just in case someone puts in some bad params:
  (if (not colorto)
      (define colorto color)
    )
  ;; first we worry about parent-relative...
  (if (cdr (assoc 'parent props-alist))
      (progn (clear-image image (get-color "red"))
	     (set-image-shape-color image (get-color "red")))
    ;;then: render the gradient or the solid to the image!
    (if (equal (cdr (assoc 'solid-gradient props-alist)) 'solid)
	;;solid is easy :)
	(clear-image image color)
      ;;gradients may be tricky :P
      (cond 
       ;;vertical, horizontal, and diagonal should be straightforward.
       ((equal 'vertical (cdr (assoc 'grad-type props-alist))) 
	(draw-vertical-gradient image color colorto))
       ((equal 'horizontal (cdr (assoc 'grad-type props-alist))) 
	(draw-horizontal-gradient image color colorto)) 
       ((equal 'diagonal (cdr (assoc 'grad-type props-alist))) 
	(draw-diagonal-gradient image color colorto))
       ;;we just flip a diagonally drawn gradient, I bet.
       ((equal 'crossdiagonal (cdr (assoc 'grad-type props-alist))) 
	(progn (draw-vertical-gradient image color colorto)
	       (flip-image-horizontally image))) 
       ;;rectangle? eit.
       
       ;;pyramid
       ;;I'm thinking draw one gradient 1/4 the size of the image, and put it
       ;;around to the other quadrants via compositing
       
       ;;pipecross? eit?
       ;;ellispe? eit?
       )
      )
    ;;then render the interlacing?
    (if (cdr (assoc 'interlaced props-alist))
	(interlace image)
      ())
    ;;then render the bevel, taking in to account the depth? 
    ;;it ought to be the right way.
    ;;note! sawfish's bevel-image ought to work! should work.
    (cond 
     ;;flat, sunken, and raised...
     ((equal 'flat (cdr (assoc 'depth props-alist))) 
      ())
     ((equal 'raised (cdr (assoc 'depth props-alist))) 
      (bevel-image image 1 t 50)) 
     ((equal 'sunken (cdr (assoc 'depth props-alist))) 
      (bevel-image image 1 () 50)))
    
    
    ;;and when we're all done, we just stop and don't really return anything
    ;;because the operations have been done on the image object itself.
    )
  )
;;brand new shiny (as of 12-1-02000) recolor image function.
(define recolor-image 
  (lambda (image color)
    (when (and (imagep image) (colorp color))
      (let*
	  ((rgb (color-rgb-8 color))
	   (red (nth 0 rgb))
	   (green (nth 1 rgb))
	   (blue (nth 2 rgb)))
	(define (transform old-pixel)
	  (and (> (nth 3 old-pixel) 0)
	       (mapcar (lambda (x) (max x 0))
		       (list (- (nth 1 old-pixel) (- 255 red))
			     (- (nth 2 old-pixel) (- 255 green))
			     (- (nth 0 old-pixel) (- 255 blue))
			     255)
		       )
	       ))
	(image-map transform image))
      image)))





;;images from the colors

;;build the images to size before rendering textures into them
;;titles
(define button-height (+ 0 (font-height title-font)))
(define label-height (+ 2 button-height))

(define window.title.focus-image
  (make-sized-image (screen-width)
		    (+ 1 (* 2 bevelwidth) button-height)))
(build-blackbox-texture window.title.focus-image
			window.title.focus-props
			window.title.focus.color
			window.title.focus.colorto)
(define window.title.unfocus-image
  (make-sized-image (screen-width)
		    (+ 1 (* 2 bevelwidth) button-height)))
(build-blackbox-texture window.title.unfocus-image
			window.title.unfocus-props
			window.title.unfocus.color
			window.title.unfocus.colorto)
;;labels
(define window.label.focus-image 
  (make-sized-image (screen-width)
		    label-height))
(build-blackbox-texture window.label.focus-image
			window.label.focus-props
			window.label.focus.color
			window.label.focus.colorto)



(define window.label.unfocus-image 
  (make-sized-image (screen-width)
		    label-height))
(build-blackbox-texture window.label.unfocus-image
			window.label.unfocus-props
			window.label.unfocus.color
			window.label.unfocus.colorto)
;;button backgrounds
(define window.button.focus-image 
  (make-sized-image button-height
		    (+ 0 button-height)))  
(build-blackbox-texture window.button.focus-image
			window.button.focus-props
			window.button.focus.color
			window.button.focus.colorto)

(define window.button.unfocus-image 
  (make-sized-image button-height
		    (+ 0 button-height)))
(build-blackbox-texture window.button.unfocus-image
			window.button.unfocus-props
			window.button.unfocus.color
			window.button.unfocus.colorto)
(define window.button.pressed-image 
  (make-sized-image button-height
		    (+ 0 button-height)))
(build-blackbox-texture window.button.pressed-image
			window.button.pressed-props
			window.button.pressed.color
			window.button.pressed.colorto)
;;button foregrounds go here.
(define (make-min-button height)
  ;;must make buttons foregrounds transparent except for 
  ;;the lines in white.
  (define minbutton (make-sized-image height height))
  (image-fill
   (lambda (x y)
     (cond ((or (equal y (- height 3)) 
		(equal y (- height 5)))
	    (if (and (>= x 2)
		     (<= x (- height 3)))
		'(255 255 255 255)
	      '(255 0 0 255)))
	   ((equal y (- height 4))
	    (if (or (equal x 2)
		    (equal x (- height 3)))
		'(255 255 255 255)
	      '(255 0 0 255)))
	   (t '(255 0 0 255))))
   minbutton)
  (set-image-shape-color minbutton (get-color "red"))
  minbutton
  )
(define min-button-images (list (recolor-image (make-min-button button-height)
					       window.button.unfocus.piccolor)
				(recolor-image (make-min-button button-height)
					       window.button.focus.piccolor)
				))

(define (make-max-button height)
  ;;must make buttons foregrounds transparent except for 
  ;;the lines in white.
  (define maxbutton (make-sized-image height height))
  (image-fill
   (lambda (x y)
     (cond ((or (equal y (- height 3)) 
		(equal y 2)
		(equal y 3))
	    (if (and (>= x 2)
		     (<= x (- height 3)))
		'(255 255 255 255)
	      '(255 0 0 255)))
	   ((and (<= y (- height 4))
		 (>= y 4))
	    (if (or (equal x 2)
		    (equal x (- height 3)))
		'(255 255 255 255)
	      '(255 0 0 255)))
	   (t '(255 0 0 255))))
   maxbutton)
  (set-image-shape-color maxbutton (get-color "red"))
  maxbutton
  )

(define max-button-images (list (recolor-image (make-max-button button-height)
					       window.button.unfocus.piccolor)
				(recolor-image (make-max-button button-height)
					       window.button.focus.piccolor)
				))

(define (make-close-button height)
  ;;must make buttons foregrounds transparent except for 
  ;;the lines in white.
  (define closebutton (make-sized-image height height))
  (image-fill
   (lambda (x y)
     (cond ((and (>= x 2) 
		 (<= x  (- height 3)))
	    (if (or (equal x y)
		    (equal x (- height y 1)))
		'(255 255 255 255)
	       '(255 0 0 255)))
	   (t '(255 0 0 255))))
   closebutton)
  (set-image-shape-color closebutton (get-color "red"))
  closebutton
  )
(define close-button-images (list 
			     (recolor-image (make-close-button button-height)
					       window.button.unfocus.piccolor)
			     (recolor-image (make-close-button button-height)
					    window.button.focus.piccolor)
			     ))

;;grips
(define window.grip.focus-image 
  (make-sized-image (+ 1 (* 2 button-height))
		    handlewidth))
(build-blackbox-texture window.grip.focus-image
			window.grip.focus-props
			window.grip.focus.color
			window.grip.focus.colorto)
(define window.grip.unfocus-image 
  (make-sized-image (+ 1 (* 2 button-height))
		    handlewidth))
(build-blackbox-texture window.grip.unfocus-image
			window.grip.unfocus-props
			window.grip.unfocus.color
			window.grip.unfocus.colorto)

;;handle
(define window.handle.focus-image 
  (make-sized-image (- (screen-width) (* 2 (font-height title-font)))
		    handlewidth))
(build-blackbox-texture window.handle.focus-image
			window.handle.focus-props
			window.handle.focus.color
			window.handle.focus.colorto)
(define window.handle.unfocus-image 
  (make-sized-image (- (screen-width) (* 2 (font-height title-font)))
		    handlewidth))
(build-blackbox-texture window.handle.unfocus-image
			window.handle.unfocus-props
			window.handle.unfocus.color
			window.handle.unfocus.colorto)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;frame parts from the images
(define window.title `((class . title)
		       (background . (,window.title.unfocus-image
				      ,window.title.focus-image))
		       (left-edge . ,(- bevelwidth))
		       (right-edge . ,(- bevelwidth))
		       (top-edge . ,(- (+ 2 (* 3 bevelwidth) 
					  borderwidth 
					  button-height)))
		       ))

(define window.label `((class . title)
		       (background . (,window.label.unfocus-image
				      ,window.label.focus-image))
		       (font . ,title-font)
		       (foreground . (,window.label.unfocus.textcolor
				      ,window.label.focus.textcolor))
		       (text . ,window-name)
		       (x-justify . center)
		       (y-justify . center)
		       (left-edge . ,(+ 1 button-height 1 bevelwidth))
		       (right-edge . ,(+ 2 (* 2 (+ button-height bevelwidth))))
		       (top-edge . ,(- (+ 2 (* 2 bevelwidth)
					  borderwidth
					  button-height)))
		       ))
;;buttons
(define window.button.minimize 
  `((class . iconify-button)
    (removable . t)
    (background . (,window.button.unfocus-image
		   ,window.button.focus-image
		   ,window.button.focus-image
		   ,window.button.pressed-image))
    (foreground . ,min-button-images)
    (left-edge . 1)
    (top-edge . ,(- (+ 1 (* 2 bevelwidth)
		       borderwidth
		       button-height
		       )))
    ))
(define window.button.maximize 
  `((class . maximize-button)
    (removable . t)
    (background . (,window.button.unfocus-image
		   ,window.button.focus-image
		   ,window.button.focus-image
		   ,window.button.pressed-image))
    (foreground . ,max-button-images)
    (right-edge . ,(+ 1 button-height bevelwidth))
    (top-edge . ,(- (+ 1 (* 2 bevelwidth)
		       borderwidth
		       button-height
		       )))
    ))
(define window.button.close 
  `((class . close-button)
    (removable . t)
    (background . (,window.button.unfocus-image
		   ,window.button.focus-image
		   ,window.button.focus-image
		   ,window.button.pressed-image))
   (foreground . ,close-button-images)
    (right-edge . 1)
    (top-edge . ,(- (+ 1 (* 2 bevelwidth)
		       borderwidth
		       button-height
		       )))
    ))
;;for the following things I think we need a custom frame part class.

(def-frame-class blackbox-border '((cursor . left_ptr)) 
  (setq blackbox-border-keymap 'title-keymap)
	)

;;the blackbox border.
(define border `((class . blackbox-border)
		 (below-client . t)
		 (background . ,bordercolor)
		 (left-edge . ,(- (+ borderwidth bevelwidth)))
		 (right-edge . ,(- (+ borderwidth bevelwidth)))
		 (top-edge . ,(- (+ 2 (* 3 bevelwidth)
				    button-height
				    (* 2 borderwidth))))
		 (bottom-edge . ,(- (+ (* 2 borderwidth)
				       bevelwidth
				       handlewidth)))
		 ))
;;and one for shaped windows, dammit.
(define shaped-border `((class . blackbox-border)
			(below-client)
			(background . ,bordercolor)
			(left-edge . ,(- (+ borderwidth bevelwidth)))
			(right-edge . ,(- (+ borderwidth bevelwidth)))
			(height . ,(+ -1 (* 2 bevelwidth)
				      handlewidth))
			(bottom-edge . ,(- (+ (* 2 borderwidth)
					      bevelwidth
					      handlewidth)))
					   ))
;;and one for shaded windows
(define shaded-border `((class . blackbox-border)
			(below-client . t)
			(background . ,bordercolor)
			(left-edge . ,(- (+ borderwidth bevelwidth)))
			(right-edge . ,(- (+ borderwidth bevelwidth)))
			(top-edge . ,(- (+ 2 (* 3 bevelwidth)
					   button-height
					   (* 2 borderwidth))))
			(height . ,(+ 0 (* 3 bevelwidth)
				      button-height
				      (* 2 borderwidth)))
			))
;;and one for transient windows.
(define transient-border `((class . blackbox-border)
			   (below-client . t)
			   (background . ,bordercolor)
			   (left-edge . ,(- (+ borderwidth bevelwidth)))
			   (right-edge . ,(- (+ borderwidth bevelwidth)))
			   (top-edge . ,(- (+ 2 (* 3 bevelwidth)
					      button-height
					      (* 2 borderwidth))))
			   (bottom-edge . ,(- (+ borderwidth bevelwidth)))))

;;the blackbox 'frame'
(define window.frame `(
		       (below-client . t)
		       (background . (,window.frame.unfocuscolor 
				      ,window.frame.focuscolor))
		       (left-edge . ,(- bevelwidth))
		       (right-edge . ,(- bevelwidth))
		       (top-edge . ,(- bevelwidth))
		       (bottom-edge . ,(- bevelwidth))
		       (class . blackbox-border)
		       ))
(define window.grip.left `((class . bottom-left-corner)
			   (background . (,window.grip.unfocus-image
					  ,window.grip.focus-image))
			   (width . ,(+ 0 (* 2 button-height)))
			   (left-edge . ,(- bevelwidth))
			   (bottom-edge . ,(- (+ borderwidth 
						 bevelwidth
						 handlewidth)))
			   ))
(define window.grip.right `((class . bottom-right-corner)
			   (background . (,window.grip.unfocus-image
					  ,window.grip.focus-image))
			   (width . ,(+ 0 (* 2 button-height)))
			   (right-edge . ,(- bevelwidth))
			   (bottom-edge . ,(- (+ borderwidth 
						 bevelwidth
						 handlewidth)))
			   ))						
(define window.handle `(
			(background . (,window.handle.unfocus-image
				       ,window.handle.focus-image))
			(bottom-edge . ,(- (+ borderwidth 
					      bevelwidth
					      handlewidth)))
			(left-edge . ,(- (+ borderwidth 1 (* 2 button-height)) 
					bevelwidth))
			(right-edge . ,(- (+ borderwidth 1 (* 2 button-height))
					  bevelwidth))
			(class . blackbox-border)
			))



;;frames from the frame parts

(define default-frame
  `(
    ,window.frame
    ,border
    ,window.title
    ,window.label
    ,window.button.minimize
    ,window.button.maximize
    ,window.button.close
    ,window.grip.left
    ,window.grip.right
    ,window.handle
    
    ))

(define shaded-frame
  `(
    ,shaded-border
    ,window.title
    ,window.label
    ,window.button.minimize
    ,window.button.maximize
    ,window.button.close
    ))

(define shaped-frame
  `(
    ,shaped-border
    ,window.title
    ,window.label
    ,window.button.minimize
    ,window.button.maximize
    ,window.button.close
    ,window.grip.left
    ,window.grip.right
    ,window.handle
    ))

(define transient-frame
  `(
    ,transient-border
    ,window.frame
    ,window.title
    ,window.label
    ,window.button.minimize
    ,window.button.maximize
    ,window.button.close
    ))

(define nil-frame `())

(add-frame-style 'chaos-direct-port
		 (lambda (w type)
		   (case type
		     ((default) default-frame)
		     ((transient) transient-frame)
		     ((shaped) shaped-frame)
		     ((shaded) shaded-frame)
		     ((shaded-transient) shaded-frame)
		     ((unframed) nil-frame))))
